#include <stdlib.h>
#include <stdio.h>
#include <stdbool.h>
#include <string.h>
#include "linklist.h"
#include "state.h"

void input(struct State* state){
    FILE * table = fopen("routing_table.txt","r");
    
    struct Node* head=NULL;
    while(true){
        char buffer[20]={'\0'};
        fgets(buffer,20,table);
        if(*buffer=='\0') break;

        struct SizedSubmask* mask=malloc(sizeof(struct SizedSubmask));
        // printf("address of new mask: %zu\n",mask);
        parse_submask(buffer,mask);

        if(head==NULL)head=xor_new(mask);
        else head=xor_insert_mid(NULL,head,mask);
    }

    state->head=head;
}

void length_distribution(struct State* state){
    usize lens[33]={0};

    struct Node* previous=NULL;
    struct Node* current=state->head;

    while(current!=NULL){
        struct Node* next=xor_next(previous,current);
        struct SizedSubmask* mask=current->val;
        lens[mask->len]++;

        // printf("address of scanning mask: %zu\n",mask);

        previous=current;
        current=next;
    }

    for(usize i=0;i<=32;i++){
        if(lens[i]!=0) printf("          There are %5zu prefix which have prefix len of %2zu\n",lens[i],i);
    }
}