#include <stdlib.h>
#include <stdio.h>
#include <stdbool.h>
#include "linklist.h"
#include "hashmap.h"
#include "state.h"
#define D 8

// assume there is no prefix like this 192.0.0.0/1, this is a strange prefix,
// because 192.0.0.0 has first two bit set, but is has submask smaller than two
bool eq(void* a,void* b){
    struct SizedSubmask* mask_a=a;
    struct SizedSubmask* mask_b=b;
    return mask_a->mask.raw==mask_b->mask.raw;
}

usize hasher(void* a){
    struct SizedSubmask* mask=a;
    return mask->mask.raw;
}

// std::collections::HashMap<SizedSubmask,XorLinklist<SizeSubmask>>
void segment(struct State* state){
    printf("          \'d\' is %2d, and empty group are skipped!\n",D);
    
    state->hashmap=malloc(sizeof(struct HashMap));
    hash_new(state->hashmap,hasher,eq);

    struct Node* previous=NULL;
    struct Node* current=state->head;

    while (current!=NULL){
        struct SizedSubmask* mask= current->val;
        struct SizedSubmask* ip=clone_submask(mask);
        if(reduce_submask(mask)){
            current=xor_remove(previous,current);
            struct Node* ll=hash_get(state->hashmap,mask);
            if(ll==NULL){
                struct Node* ll=xor_new(ip);
                hash_insert(state->hashmap,mask,ll);
            }else{
                xor_insert_front(ll,ip);
                free(mask);
            }
        }else{
            struct Node* next=xor_next(previous,current);
            previous=current;
            current=next;
            free(ip);
        }
    }

    state->head=previous;

    for(usize i=0;i<B;i++){
        struct Entry *entry=state->hashmap->entry+i;
        for(usize j=0;j<entry->size;j++){
            struct SizedSubmask* mask=entry->list[j].key;
            struct Node* ll=entry->list[j].val;
            usize count=xor_count(ll);
            if(count!=0){
                printf("          There are %5zu prefix in group %10u (",count,mask->mask.raw);
                display_submask(mask);
                printf(")\n");
            }
        }
    }
}